CREATE TABLE xar_block_group_instances (id INTEGER  NOT NULL  , group_id INTEGER  NOT NULL DEFAULT '0' , instance_id INTEGER  NOT NULL DEFAULT '0' , template VARCHAR(100)    , position INTEGER  NOT NULL DEFAULT '0' , PRIMARY KEY (id));
CREATE TABLE xar_block_groups (id INTEGER  NOT NULL  , name VARCHAR(255)  NOT NULL DEFAULT '' , template VARCHAR(255)  NOT NULL DEFAULT '' , PRIMARY KEY (id));
CREATE TABLE xar_block_instances (id INTEGER  NOT NULL  , type_id INTEGER  NOT NULL DEFAULT '0' , name VARCHAR(100)  NOT NULL  , title VARCHAR(255)    , content TEXT  NOT NULL  , template VARCHAR(255)    , state INTEGER  NOT NULL DEFAULT '2' , refresh INTEGER  NOT NULL DEFAULT '0' , last_update INTEGER  NOT NULL DEFAULT '0' , PRIMARY KEY (id));
CREATE TABLE xar_block_types (id INTEGER  NOT NULL  , type VARCHAR(64)  NOT NULL DEFAULT '' , modid INTEGER UNSIGNED NOT NULL DEFAULT '0' , info TEXT    , PRIMARY KEY (id));
CREATE TABLE xar_cache_blocks (id INTEGER  NOT NULL DEFAULT '0' , nocache INTEGER  NOT NULL DEFAULT '0' , page INTEGER  NOT NULL DEFAULT '0' , user INTEGER  NOT NULL DEFAULT '0' , expire INTEGER    , PRIMARY KEY (id));
CREATE TABLE xar_dynamic_data (dd_id INTEGER  NOT NULL DEFAULT '0' , dd_propid INTEGER  NOT NULL DEFAULT '0' , dd_itemid INTEGER  NOT NULL DEFAULT '0' , dd_value TEXT    , PRIMARY KEY (dd_id));
CREATE TABLE xar_dynamic_objects (object_id INTEGER  NOT NULL DEFAULT '0' , object_name VARCHAR(30)  NOT NULL DEFAULT '' , object_label VARCHAR(254)  NOT NULL DEFAULT '' , object_moduleid INTEGER  NOT NULL DEFAULT '0' , object_itemtype INTEGER  NOT NULL DEFAULT '0' , object_parent INTEGER  NOT NULL DEFAULT '0' , object_class VARCHAR(255)  NOT NULL DEFAULT 'DataObject' , object_filepath VARCHAR(255)  NOT NULL DEFAULT 'modules/dynamicdata/class/objects/base.php' , object_urlparam VARCHAR(30)  NOT NULL DEFAULT 'itemid' , object_maxid INTEGER  NOT NULL DEFAULT '0' , object_config TEXT    , object_isalias INTEGER  NOT NULL DEFAULT '1' , PRIMARY KEY (object_id));
CREATE TABLE xar_dynamic_properties (prop_id INTEGER  NOT NULL DEFAULT '0' , prop_name VARCHAR(30)  NOT NULL DEFAULT '' , prop_label VARCHAR(254)  NOT NULL DEFAULT '' , prop_objectid INTEGER  NOT NULL DEFAULT '0' , prop_type INTEGER  NOT NULL  , prop_default VARCHAR(254)    , prop_source VARCHAR(254)  NOT NULL DEFAULT 'dynamic_data' , prop_status INTEGER  NOT NULL DEFAULT '33' , prop_order INTEGER  NOT NULL DEFAULT '0' , prop_validation TEXT    , PRIMARY KEY (prop_id));
CREATE TABLE xar_dynamic_properties_def (prop_id INTEGER  NOT NULL DEFAULT '0' , prop_name VARCHAR(254)    , prop_label VARCHAR(254)    , prop_parent VARCHAR(254)    , prop_filepath VARCHAR(254)    , prop_class VARCHAR(254)    , prop_validation VARCHAR(254)    , prop_source VARCHAR(254)    , prop_reqfiles VARCHAR(254)    , prop_modid INTEGER    , prop_args TEXT  NOT NULL  , prop_aliases VARCHAR(254)    , prop_format INTEGER   DEFAULT '0' , PRIMARY KEY (prop_id));
CREATE TABLE xar_hooks (id INTEGER  NOT NULL  , object VARCHAR(64)  NOT NULL  , action VARCHAR(64)  NOT NULL  , s_module_id INTEGER    , s_type VARCHAR(64)  NOT NULL DEFAULT '' , t_area VARCHAR(64)  NOT NULL  , t_module_id INTEGER  NOT NULL  , t_type VARCHAR(64)  NOT NULL  , t_func VARCHAR(64)  NOT NULL  , priority INTEGER  NOT NULL DEFAULT '0' , PRIMARY KEY (id));
CREATE TABLE xar_module_itemvars (module_var_id INTEGER  NOT NULL  , item_id INTEGER UNSIGNED NOT NULL  , value TEXT    , PRIMARY KEY (module_var_id,item_id));
CREATE TABLE xar_module_vars (id INTEGER  NOT NULL  , module_id INTEGER    , name VARCHAR(64)  NOT NULL  , value TEXT    , PRIMARY KEY (id));
CREATE TABLE xar_modules (id INTEGER  NOT NULL  , name VARCHAR(64)  NOT NULL  , regid INTEGER    , directory VARCHAR(64)  NOT NULL  , version VARCHAR(10)  NOT NULL  , class VARCHAR(64)  NOT NULL  , category VARCHAR(64)  NOT NULL  , admin_capable INTEGER  NOT NULL DEFAULT '0' , user_capable INTEGER  NOT NULL DEFAULT '0' , state INTEGER  NOT NULL DEFAULT '1' , PRIMARY KEY (id));
CREATE TABLE xar_privileges (id INTEGER  NOT NULL DEFAULT '0' , name VARCHAR(100)  NOT NULL DEFAULT '' , realm_id INTEGER    , module_id INTEGER    , component VARCHAR(100)  NOT NULL DEFAULT '' , instance VARCHAR(100)  NOT NULL DEFAULT '' , level INTEGER  NOT NULL DEFAULT '0' , description VARCHAR(255)  NOT NULL DEFAULT '' , type INTEGER  NOT NULL DEFAULT '0' , PRIMARY KEY (id));
CREATE TABLE xar_privmembers (id INTEGER    , parentid INTEGER    );
CREATE TABLE xar_rolemembers (id INTEGER    , parentid INTEGER    );
CREATE TABLE xar_roles (id INTEGER  NOT NULL DEFAULT '0' , name VARCHAR(255)  NOT NULL DEFAULT '' , type INTEGER  NOT NULL DEFAULT '0' , users INTEGER  NOT NULL DEFAULT '0' , uname VARCHAR(255)  NOT NULL DEFAULT '' , email VARCHAR(255)  NOT NULL DEFAULT '' , pass VARCHAR(100)  NOT NULL DEFAULT '' , date_reg INTEGER  NOT NULL DEFAULT '0' , valcode VARCHAR(35)  NOT NULL DEFAULT '' , state INTEGER  NOT NULL DEFAULT '3' , auth_modid INTEGER  NOT NULL DEFAULT '0' , PRIMARY KEY (id));
CREATE TABLE xar_security_acl (partid INTEGER  NOT NULL DEFAULT '0' , permid INTEGER  NOT NULL DEFAULT '0' , PRIMARY KEY (partid,permid));
CREATE TABLE xar_security_instances (id INTEGER  NOT NULL DEFAULT '0' , module_id INTEGER  NOT NULL DEFAULT '0' , component VARCHAR(100)  NOT NULL DEFAULT '' , header VARCHAR(255)  NOT NULL DEFAULT '' , query VARCHAR(255)  NOT NULL DEFAULT '' , ddlimit INTEGER  NOT NULL DEFAULT '0' , propagate INTEGER  NOT NULL DEFAULT '0' , instancetable2 VARCHAR(100)  NOT NULL DEFAULT '' , instancechildid VARCHAR(100)  NOT NULL DEFAULT '' , instanceparentid VARCHAR(100)  NOT NULL DEFAULT '' , description VARCHAR(255)  NOT NULL DEFAULT '' , PRIMARY KEY (id));
CREATE TABLE xar_security_realms (id INTEGER  NOT NULL DEFAULT '0' , name VARCHAR(255)  NOT NULL DEFAULT '' , PRIMARY KEY (id));
CREATE TABLE xar_session_info (id VARCHAR(32)  NOT NULL  , ip_addr VARCHAR(20)  NOT NULL  , first_use INTEGER  NOT NULL DEFAULT '0' , last_use INTEGER  NOT NULL DEFAULT '0' , role_id INTEGER  NOT NULL DEFAULT '0' , vars BLOB    , remember INTEGER   DEFAULT '0' , PRIMARY KEY (id));
CREATE TABLE xar_themes (id INTEGER  NOT NULL  , name VARCHAR(64)  NOT NULL  , regid INTEGER    , directory VARCHAR(64)  NOT NULL  , author VARCHAR(64)  NOT NULL  , homepage VARCHAR(64)  NOT NULL  , email VARCHAR(64)  NOT NULL  , description VARCHAR(255)  NOT NULL  , contactinfo VARCHAR(255)  NOT NULL  , publishdate VARCHAR(32)  NOT NULL  , license VARCHAR(255)  NOT NULL  , version VARCHAR(10)  NOT NULL  , xaraya_version VARCHAR(10)  NOT NULL  , bl_version VARCHAR(10)  NOT NULL  , class INTEGER  NOT NULL DEFAULT '0' , state INTEGER  NOT NULL DEFAULT '1' , PRIMARY KEY (id));

CREATE INDEX i_xar_block_group_instances ON xar_block_group_instances (group_id);
CREATE INDEX i_xar_block_group_instances_2 ON xar_block_group_instances (instance_id);
CREATE UNIQUE INDEX i_xar_block_groups ON xar_block_groups (name);
CREATE INDEX i_xar_block_instances ON xar_block_instances (type_id);
CREATE UNIQUE INDEX i_xar_block_instances_u2 ON xar_block_instances (name);
CREATE UNIQUE INDEX i_xar_block_types2 ON xar_block_types (modid,type);
CREATE UNIQUE INDEX i_xar_config_name ON xar_module_vars (name,module_id);
CREATE INDEX i_xar_dyndata_itemid ON xar_dynamic_data (dd_itemid);
CREATE INDEX i_xar_dyndata_propid ON xar_dynamic_data (dd_propid);
CREATE UNIQUE INDEX i_xar_dynobjects_combo ON xar_dynamic_objects (object_moduleid,object_itemtype);
CREATE UNIQUE INDEX i_xar_dynobjects_name ON xar_dynamic_objects (object_name);
CREATE INDEX i_xar_dynpropdef_modid ON xar_dynamic_properties_def (prop_modid);
CREATE UNIQUE INDEX i_xar_dynprops_combo ON xar_dynamic_properties (prop_objectid,prop_name);
CREATE INDEX i_xar_module_vars_module_id ON xar_module_vars (module_id);
CREATE INDEX i_xar_module_vars_name ON xar_module_vars (name);
CREATE INDEX i_xar_privileges_level ON xar_privileges (level);
CREATE INDEX i_xar_privileges_module ON xar_privileges (module_id);
CREATE UNIQUE INDEX i_xar_privileges_name ON xar_privileges (name,module_id,type);
CREATE INDEX i_xar_privileges_realm_id ON xar_privileges (realmid);
CREATE INDEX i_xar_privmembers_parentid ON xar_privmembers (parentid);
CREATE INDEX i_xar_privmembers_pid ON xar_privmembers (id);
CREATE INDEX i_xar_rolememb_id ON xar_rolemembers (id);
CREATE INDEX i_xar_rolememb_parentid ON xar_rolemembers (parentid);
CREATE INDEX i_xar_roles_email ON xar_roles (email);
CREATE INDEX i_xar_roles_name ON xar_roles (name);
CREATE INDEX i_xar_roles_state ON xar_roles (state);
CREATE INDEX i_xar_roles_type ON xar_roles (type);
CREATE UNIQUE INDEX i_xar_roles_uname ON xar_roles (uname);
CREATE INDEX i_xar_security_acl_partid ON xar_security_acl (partid);
CREATE INDEX i_xar_security_acl_permid ON xar_security_acl (permid);
CREATE INDEX i_xar_session_last_use ON xar_session_info (last_use);
CREATE INDEX i_xar_session_role_id ON xar_session_info (role_id);
